#include "strategy1.h"
#include "strategy2.h"
#include "strategy3.h"

#include <iostream>

int main(int argc, char *argv[])
{
        SudokuBoard board;
        SudokuStrategy1 strategy1;
        SudokuStrategy2 strategy2;
        SudokuStrategy3 strategy3;

        // Initialize board values
	char *filename = "board.txt";
	if(argc > 1)
		filename = argv[1];

	board.read(filename);
	if(!board.is_valid())
	{
		std::cout << "Board is not valid." << std::endl;
		return -1;
	}
	std::cout << "Initial board:" << std::endl;
	board.print();

        int passes = 0;
	bool changed;
        do
        {
		changed = false;
                passes++;
// Change to 0 to apply brute force only
#if 1
                if(strategy1(board) == true)
                        changed = true;
                if(strategy2(board) == true)
                        changed = true;
#endif
        } while(changed == true);

        std::cout << "Stopped after " << passes << ((passes == 1) ? " pass" : " passes") << std::endl;
	board.print();

	if(!board.is_solved())
	{
		std::cout << "Board remains unsolved, applying brute force" << std::endl;
		strategy3(board);
		board.print();
	}

        return 0;
}

